package com.aurellem.capture.audio;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.Vector;

import javax.sound.sampled.AudioFileFormat;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;

public class WaveFileWriter implements SoundProcessor {

	public Vector<Byte> fullWaveData = new Vector<Byte>();
	public File targetFile;
	
	public WaveFileWriter(File targetFile){
		this.targetFile = targetFile;
	}
	
	public void cleanup() {
		byte[] data = new byte[this.fullWaveData.size()];
		
		for (int i = 0; i < this.fullWaveData.size(); i++){
			data[i] = this.fullWaveData.get(i);}
		
		ByteArrayInputStream input = new ByteArrayInputStream(data);
		AudioFormat format = new AudioFormat(44100.0f, 32, 1, true, false); 
		AudioInputStream audioInput = new AudioInputStream(input, format, data.length / 4 );
		try {AudioSystem.write(audioInput, AudioFileFormat.Type.WAVE, targetFile);} 
		catch (IOException e) {e.printStackTrace();}

	}

	
	public void process(ByteBuffer audioSamples, int numSamples) {
		for (int i = 0; i<numSamples; i++){
			Byte b = audioSamples.get(i);
			fullWaveData.add(b);
		}
	}

}
